function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var EasyDraggable = /*#__PURE__*/function (_Component) {
  _inheritsLoose(EasyDraggable, _Component);

  function EasyDraggable(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.down = function (e, node, position) {
      var currentTargetRect = e.currentTarget.getBoundingClientRect();
      var event_offsetX = e.pageX - window.pageXOffset - currentTargetRect.left,
          event_offsetY = e.pageY - window.pageYOffset - currentTargetRect.top;

      _this.setState({
        clickX: event_offsetX
      });

      _this.setState({
        clickY: event_offsetY
      });

      _this.setState({
        cursor: _this.props.cursor
      });

      if (_this.props.onDragStart) _this.props.onDragStart(node.name);

      _this.setState({
        isMoving: parseInt(node.id)
      });

      _this.setState({
        initial: position
      });
    };

    _this.pauseEvent = function (e) {
      if (e.stopPropagation) e.stopPropagation();
      if (e.preventDefault) e.preventDefault();
      e.cancelBubble = true;
      e.returnValue = false;
      return false;
    };

    _this.generalHover = function (e) {
      _this.pauseEvent(e);

      _this.setState({
        pageX: e.pageX
      });

      _this.setState({
        pageY: e.pageY
      });
    };

    _this.hover = function (e, id, i) {
      _this.pauseEvent(e);

      var itemIndex = i;

      if (_this.state.isMoving != null) {
        var temp = [].concat(_this.state.data);
        var startingPos = _this.state.initial;
        var startingElem = temp[startingPos];
        temp.splice(startingPos, 1);
        temp.splice(itemIndex, 0, startingElem);

        _this.setState({
          initial: itemIndex
        });

        _this.setState({
          endKey: itemIndex
        });

        _this.setState({
          data: temp
        });

        if (_this.props.onItemSwitch) _this.props.onItemSwitch(temp);
      } else {
        if (_this.props.onItemHover) {
          _this.props.onItemHover(id.key, i);
        }
      }
    };

    _this.up = function (e) {
      _this.pauseEvent(e);

      if (_this.props.onDragStop) _this.props.onDragStop(_this.state.endKey);

      _this.setState({
        isMoving: null
      });
    };

    _this.init = function () {
      var items = [].concat(_this.props.children);

      _this.setState({
        cursor: _this.props.cursor
      });

      items.length > 0 ? items = items.map(function (item) {
        return Object.assign({}, item);
      }) : Object.assign({}, items);

      for (var _iterator = _createForOfIteratorHelperLoose(items.entries()), _step; !(_step = _iterator()).done;) {
        var _step$value = _step.value,
            i = _step$value[0],
            item = _step$value[1];
        var isDraggable = true;

        if (item) {
          if (item.isDraggable == false) {
            isDraggable = false;
          }
        }

        items[i].id = i;
        items[i].name = items[i].key;
        items[i].isDraggable = isDraggable;
      }

      _this.setState({
        data: items
      });
    };

    _this.state = {
      overWidth: null,
      overHeight: null,
      data: [],
      clickX: 0,
      clickY: 0
    };
    return _this;
  }

  var _proto = EasyDraggable.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.setState({
      itemPerRow: this.props.itemsPerRow
    });
    this.init();
    window.addEventListener('resize', function (e) {
      if (_this2.ref) {
        var height = _this2.ref.clientHeight;
        var width = _this2.ref.clientWidth;

        _this2.setState({
          overWidth: width
        });

        _this2.setState({
          overHeight: height
        });
      }
    });
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevP, prevState) {
    if (prevP.children != this.props.children && this.state.isMoving == null) {
      this.init();
    }

    if (this.state.data != prevState.data) {
      if (document.getElementsByClassName('modern-item')[0]) {
        if (this.props.handle) {
          var _height = document.getElementsByClassName('modern-handle')[0].clientHeight;
          var _width = document.getElementsByClassName('modern-handle')[0].clientWidth;
          this.setState({
            offsetWidth: _width
          });
          this.setState({
            offsetHeight: _height
          });
        } else {
          var _height2 = document.getElementsByClassName('modern-item')[0].clientHeight;
          var _width2 = document.getElementsByClassName('modern-item')[0].clientWidth;
          this.setState({
            offsetWidth: _width2
          });
          this.setState({
            offsetHeight: _height2
          });
        }

        var height = this.state.height;
        var width = this.state.width;

        if (this.ref) {
          height = this.ref.clientHeight;
          width = this.ref.clientWidth;
        }

        this.setState({
          overWidth: width
        });
        this.setState({
          overHeight: height
        });
      }
    }

    if (this.props.itemsPerRow != prevP.itemsPerRow) {
      this.setState({
        itemPerRow: this.props.itemsPerRow
      });
      this.setState({
        overWidth: 'auto'
      });
      this.setState({
        overHeight: 'auto'
      });
      this.init();
    }

    if (prevP.children.length != this.props.children.length) {
      this.init();
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    var temp = [];
    var secu = [];
    var gridClass = '';
    var htmlData = [];
    var items = [].concat(this.state.data);

    if (items) {
      for (var j = 0; j < this.props.itemsPerRow; j++) {
        gridClass = gridClass + '1fr ';
      }

      var onlast = items.length % this.props.itemsPerRow;
      var length = this.props.itemsPerRow - onlast;

      for (var _j = 0; _j < length; _j++) {
        secu.push( /*#__PURE__*/React__default.createElement("div", {
          id: items.length + _j + '-' + 3,
          onMouseUp: function onMouseUp(e) {
            return _this3.up(e);
          },
          style: {
            left: this.state.pageX - this.state.clickX,
            top: this.state.pageY - this.state.clickY,
            position: 'relative',
            zIndex: 100,
            height: '100%',
            cursor: this.props.handle ? 'auto' : this.state.cursor,
            marginTop: this.props.vSpacing,
            marginBottom: this.props.vSpacing,
            marginLeft: this.props.hSpacing,
            marginRight: this.props.hSpacing
          }
        }, "\xA0"));
      }

      htmlData = items.map(function (item, i) {
        if (item) {
          var _React$createElement;

          var _htmlData = /*#__PURE__*/React__default.createElement("div", (_React$createElement = {
            className: "modern-item",
            onMouseDown: function onMouseDown(e) {
              return !_this3.props.handle ? _this3.down(e, item, i) : '';
            },
            style: {
              overflow: 'hidden',
              minWidth: 0
            },
            onMouseEnter: function onMouseEnter(e) {
              return _this3.hover(e, item, i);
            },
            onMouseUp: function onMouseUp(e) {
              return _this3.up(e, item.id);
            },
            ref: function ref(_ref) {
              _this3.ref = _ref;
            }
          }, _React$createElement["style"] = _this3.state.isMoving == item.id ? {
            marginTop: _this3.props.vSpacing,
            marginBottom: _this3.props.vSpacing,
            position: 'static',
            zIndex: 100,
            width: _this3.state.overWidth,
            height: _this3.state.overHeight,
            marginLeft: _this3.props.hSpacing,
            marginRight: _this3.props.hSpacing
          } : {
            marginTop: _this3.props.vSpacing,
            marginBottom: _this3.props.vSpacing,
            position: 'relative',
            zIndex: 110,
            height: 'auto',
            width: 'auto',
            marginLeft: _this3.props.hSpacing,
            marginRight: _this3.props.hSpacing
          }, _React$createElement), /*#__PURE__*/React__default.createElement("div", {
            id: item.id + '-' + i,
            style: _this3.state.isMoving == item.id ? {
              cursor: _this3.props.handle ? 'auto' : _this3.state.cursor,
              width: _this3.state.overWidth,
              height: _this3.state.overHeight,
              position: 'absolute',
              left: _this3.state.pageX - _this3.state.clickX,
              top: _this3.state.pageY - _this3.state.clickY
            } : {
              cursor: _this3.props.handle ? 'auto' : _this3.state.cursor,
              height: 'auto',
              width: 'auto'
            }
          }, _this3.props.handle && /*#__PURE__*/React__default.createElement("div", {
            style: {
              cursor: _this3.props.handle ? 'auto' : _this3.state.cursor,
              display: 'inline-block'
            },
            className: "modern-handle",
            onMouseDown: function onMouseDown(e) {
              return _this3.down(e, item, i);
            }
          }, _this3.props.handle), /*#__PURE__*/React__default.createElement("div", {
            style: (_this3.state.isMoving == item.id ? {
              cursor: _this3.props.handle ? 'auto' : _this3.state.cursor,
              width: _this3.state.overWidth,
              height: _this3.state.overHeight
            } : {
              height: 'auto',
              width: 'auto'
            })
          }, item.props ? item.props.children : item)));

          if (items.length <= _this3.props.itemsPerRow) {
            temp.push(_htmlData);

            if (i == items.length - 1) {
              return /*#__PURE__*/React__default.createElement("div", {
                style: {
                  overflow: 'hidden',
                  display: 'grid',
                  minHeight: 0,
                  minWidth: 0,
                  gridTemplateColumns: gridClass,
                  position: 'static'
                }
              }, temp);
            }
          } else {
            temp.push(_htmlData);

            if (i == items.length - 1) {
              return /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("div", {
                style: {
                  overflow: 'hidden',
                  display: 'grid',
                  minHeight: 0,
                  minWidth: 0,
                  gridTemplateColumns: gridClass,
                  position: 'static'
                }
              }, temp, secu));
            }
          }
        }
      });
    }

    return /*#__PURE__*/React__default.createElement("div", {
      ref: function ref(_ref2) {
        _this3.cursor = _ref2;
      },
      style: {
        maxWidth: '100vw',
        overflow: 'hidden'
      },
      onMouseMove: function onMouseMove(e) {
        return _this3.generalHover(e);
      }
    }, htmlData);
  };

  return EasyDraggable;
}(React.Component);

var EasyItem = /*#__PURE__*/function (_Component) {
  _inheritsLoose(EasyItem, _Component);

  function EasyItem(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {};
    return _this;
  }

  var _proto = EasyItem.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/React__default.createElement("div", null);
  };

  return EasyItem;
}(React.Component);

exports.EasyDraggable = EasyDraggable;
exports.EasyItem = EasyItem;
//# sourceMappingURL=index.js.map
